

function newBlocks()
	for i=1, math.random(5) do
		local block = {
			x = math.multiple(math.random(field.width-50),50),
			y = -50,
			xvel = 0,
			yvel = 50,
			life = 30,
			state = 'falling'
		}

		table.insert(gWorld,block)
	end
end

function updateBlocks(dt)
	local shake = 0.2
	for i,v in ipairs(gWorld) do
		local kill = false

		if v.state == 'falling' or v.state == 'static' then
			v.y = v.y - v.yvel*dt
			v.yvel = v.yvel - Gravity*dt
			v.life = v.life - dt
			
			for ii,vv in ipairs(gWorld) do
				if v ~= vv then
					if v.x == vv.x
					and v.y > vv.y-50
					and v.y < vv.y then
						v.y = vv.y-50
						v.yvel = 0
						if v.state == 'falling' then
							v.state = 'static'
							fireShake(shake)
						end
					end
				end
			end

			if v.life > 0 then
				if v.y > 550 then
					v.y = 550
					v.yvel = 0
					if v.state == 'falling' then
						v.state = 'static'
						fireShake(shake)
					end
				end
			elseif v.y > 800 then
				kill = true
			end


			if v.yvel > 0 then
				v.state = 'falling'
			end
		else
			v.stop = v.stop-dt
			if v.stop < 0 then
				v.x = v.x + v.xvel*dt
			end

			local function stopFlying(x,rem)
				if v.hit > 0 then
					v.hit = v.hit - 1
					v.stop = 0.1
					table.remove(gWorld,rem)
				else
					v.xvel = 0
					v.yvel = 0
					v.state = 'falling'
					v.x = x
					fireShake(-shake)
				end
			end

			for ii,vv in pairs(gWorld) do
				if v ~= vv then
					if CheckCollision(v.x,v.y,50,50, vv.x,vv.y,50,50)
					and (vv.y > v.y or v.y-vv.y < 40) then
						if v.x < vv.x then
							stopFlying(vv.x-50,ii)
						else
							stopFlying(vv.x+50,ii)
						end
					end
				end
			end

			if v.x > field.width or v.x < -50 then
				kill = true
			end
		end

		if kill then
			table.remove(gWorld,i)
		end
	end
end

function drawBlocks()
	for i,v in pairs(gWorld) do
		local colors = {
			['falling'] = {100,150,200},
			['static'] = {100,150,200},
			['bullet'] = {30,180,30}
		}

		love.graphics.setColor(colors[v.state])
		love.graphics.draw(blockimg,v.x,v.y,0,2,2)
		love.graphics.setColor(0,0,0)
--		love.graphics.print(i,v.x+10,v.y+10)
	end
	love.graphics.setColor(255,255,255)
end