function love.load()
	love.graphics.setDefaultImageFilter('linear','nearest')
	love.graphics.setPoint(3,'smooth')

	require 'extra'

	blockimg = love.graphics.newImage('img/block.png')

	screen = {
		width = love.graphics.getWidth(),
		height = love.graphics.getHeight()
	}

	field = {
		width = 3200
	}

	gWorld = {}
	gTime = 0
	gTick = newTick()

	Gravity = 700

	Controls = {
		right = 'right',
		left = 'left',
		jump = 'up',
		grab = 'z'
	}

	JoyControls = {
		jump = 3,
		grab = 4
	}

	require 'camera'
	require 'camerashake'
	require 'block'
	require 'player'

	startTimer = 1
end

function love.update(dt)
	updatePlayer(dt)
	updateCamera(dt)
	updateShake(dt)

	startTimer = startTimer - dt
	if startTimer > 0 then return end

	updateBlocks(dt)
	
	gTime = gTime+dt
	if gTime > gTick then
		gTime = gTime-gTick
		gTick = newTick()

		newBlocks()
	end
end

function love.draw()
	drawCamera()
	drawShake()
	drawBlocks()
	drawPlayer()

	love.graphics.rectangle('fill',0,screen.height,field.width,100)
end

function love.keypressed(k)
	keyPlayer(k)
end

function love.keyreleased(k)
	keyLiftPlayer(k)
end

function love.joystickpressed(joy,b)
	keyPlayer(b)
end

function love.joystickreleased(joy,b)
	keyLiftPlayer(b)
end

function newTick() return math.random() + 0.5 end