local player = {
	x = field.width/2 - 25,
	y = 100,
	yvel = 0,
	speed = 500,
	img = love.graphics.newImage('img/player.png'),
	glow = 0,
	collisionState = 'none',
	grav = 3000,
	jump = false,
	holding = false,
	dir = 1
}

function updatePlayer(dt)
	local left = love.keyboard.isDown(Controls.left)
	local right = love.keyboard.isDown(Controls.right)

	local axisX = love.joystick.getAxes(1)

	local f = player.speed*dt
	local center = screen.width/2 - 25 + getCamera().x

	local moveX,moveY = player.x,player.y

	--vertical movement
	moveY = player.y + player.yvel*dt
	for i,v in pairs(gWorld) do
		if CheckCollision(player.x,moveY,50,50, v.x,v.y,50,50) then
			if moveY > player.y then
				player.yvel = 0
				player.jump = true
			else
				if v.yvel == 0 then
					resetPlayer()
					return
				end
			end
			if moveY > v.y then
				moveY = v.y+50
			else
				moveY = v.y-50
			end
			break
		end
	end
	player.yvel = player.yvel + player.grav*dt
	player.y = moveY

	--horizontal movement
	if right or axisX==1  then
		moveX = player.x + f
		player.dir = 1
	elseif left or axisX==-1 then
		moveX = player.x - f
		player.dir = -1
	end
	for i,v in pairs(gWorld) do
		if CheckCollision(moveX,player.y,50,50, v.x,v.y,50,50) then
			if moveX > v.x then
				moveX = v.x+50
			else
				moveX = v.x-50
			end
			break
		end
	end
	player.x = math.clamp(0,moveX,field.width-50)
	moveCamera(math.clamp(0, player.x - screen.width/2, field.width-screen.width))

	if player.y > 550 then
		player.y = 550
		player.yvel = 0
		player.jump = true
	end

	player.glow = player.glow + dt*5
end

function keyPlayer(k)
	if (k==Controls.jump or k==JoyControls.jump) and player.jump then
		player.yvel = -1200
		player.jump = false
	end
	if not player.holding then
		if k==Controls.grab or k==JoyControls.grab then
			for i,v in pairs(gWorld) do
				local diffX = (v.x - (player.x + 50*player.dir))*player.dir
				local diffY = math.abs(v.y - player.y)
				local cond
				if diffX >= 0 and diffX < 50 and diffY < 25 then
					player.holding = true
					table.remove(gWorld,i)
				end
			end
		end
	end
end

function keyLiftPlayer(k)
	if (k==Controls.grab or k==JoyControls.grab) and player.holding == true then
		local crack = {
			x = player.x + 50*player.dir,
			y = player.y,
			xvel = 1000 * player.dir,
			yvel = 0,
			life = 30,
			state = 'bullet',
			stop = 0,
			hit = 2
		}

		table.insert(gWorld,crack)
		player.holding = false
	end
end

function resetPlayer()
	player.x = field.width/2 - 25
	player.y = 100
	player.yvel = 0
end

function drawPlayer()
	local glow = math.max((math.sin(player.glow) + 0.5)*50,0)
	love.graphics.setColor(150+glow,glow,glow)
	love.graphics.draw(player.img,player.x,player.y,0,2,2)

	if player.holding then
		love.graphics.draw(blockimg,player.x + 50*player.dir, player.y,0,2,2)
	else
		love.graphics.point(player.x + 25 + 35*player.dir, player.y+25)
	end
	love.graphics.setColor(255,255,255)

--	love.graphics.print('collision: '..player.collisionState,0+getCamera().x,0)
end